#include "GWt_console.h"

#include <Wt/WApplication>
#include <Wt/WText>
#include <Wt/WBorder>
#include <Wt/WLayout>
#include <Wt/WPanel>
#include <Wt/WScrollArea>

GWt_console::GWt_console()
:WContainerWidget()
{
    setObjectName("console");

    // le panel
    WPanel *panelConsole = new WPanel(this);
    WScrollArea* container = new  WScrollArea();
    
    panelConsole->setTitle(" output");
    output_ = new WText(this);
    output_->setTextFormat(PlainText);
    output_->setInline(false);

    container->setWidget(output_);

    panelConsole->setCentralWidget(container);
    output_->setMinimumSize(270,100);
    output_->setMaximumSize(400,400);

    container->setStyleClass("console");
}


GWt_console::~GWt_console()
{
}


void GWt_console::addConsoleMessage(WString msg) {
    
    output_->setText(output_->text()+msg);
    
    /*
     * Little javascript trick to make sure we scroll along with new content
     */
    wApp->doJavaScript(output_->jsRef() + ".scrollTop += "
                       + output_->jsRef() + ".scrollHeight;");
    
}

